Library IEEE;
Use IEEE.std_logic_1164.all;


Entity controlunit is

	port(clk:in std_logic;
	     d:in std_logic_vector(6 downto 0);
	     timer:in std_logic_vector(2 downto 0);
	     AND_SIG, ADD_SIG, RST_SC, TST_DRZ:out std_logic;
	     LOAD_DR, READ_DR, INC_DR: out std_logic;
	     LOAD_AC, READ_AC, INC_AC, CLR_AC, COM_AC, SHL_AC, SHR_AC: out std_logic;
	     LOAD_AR, READ_AR, INC_AR: out std_logic;
	     READ_PC, INC_PC, CLR_PC, LOAD_PC: out std_logic;
	     LOAD_IR, READ_IR: out std_logic;
	     LOAD_OUTR, READ_OUTR: out std_logic;
	     READ_MEM, WRITE_MEM: out std_logic);
	     
end controlunit;


Architecture controlunit_arch of controlunit is
	begin
	process(clk, d, timer)
	begin
		if(clk'event and clk ='1') then
			case d is
				when "0000001" =>	-- AND OPERATION (D0)
					if(timer = "100") then
						READ_MEM <= '1';
						LOAD_DR <= '1';
							
					elsif(timer = "101")then
						READ_DR <='1';
						AND_SIG <= '1';
						LOAD_AC <= '1';
						RST_SC <= '1';	
					end if;
					
				when "0000010" =>	-- ADD OPERATION (D1)
					if(timer = "100") then
						READ_MEM <= '1';
						LOAD_DR <= '1';
							
					elsif(timer = "101")then
						READ_DR <='1';
						ADD_SIG <= '1';
						LOAD_AC <= '1';
						RST_SC <= '1';
					end if;
				
				when "0000100" =>	-- LDA OPERATION (D2)
					if(timer = "100") then
						READ_MEM <= '1';
						LOAD_DR <= '1';
						
					elsif (timer = "101") then
						READ_DR <= '1';
						LOAD_AC <= '1';
						RST_SC <= '1';
					end if;
				
				when "0001000" =>	-- STA OPERATION (D3)
					if(timer = "100") then
						READ_AC <= '1';
						READ_AR <= '1';
						WRITE_MEM <= '1';
					end if;
					
				when "0010000" =>	-- BUN OPERATION (D4)
					if(timer = "100") then
						READ_AR <= '1';
						LOAD_PC <= '1';
						RST_SC <= '1';
					end if;
					
				when "0100000" =>	-- BSA OPERATION (D5)
					if (timer = "100") then
						READ_PC <= '1';
						INC_AR <= '1';
						
					elsif(timer = "101") then
						READ_AR <= '1';
						LOAD_PC <= '1';
						RST_SC <= '1';
					end if;
				
				when "1000000" =>	-- ISZ OPERATION (D6)
					if(timer = "100") then
						READ_MEM <= '1';
						LOAD_DR <= '1';
						
					elsif (timer ="101") then
						INC_DR <= '1';
						
					elsif (timer = "110") then
						READ_DR <= '1';
						WRITE_MEM <= '1';
						TST_DRZ <= '1';
						RST_SC <= '1';
					end if;
					
				when others =>
				     AND_SIG <= '0';
				     ADD_SIG <= '0';
				     RST_SC <= '0';
				     TST_DRZ <= '0';
				     LOAD_DR <= '0';
				     READ_DR <= '0';
				     INC_DR <= '0';
				     LOAD_AC <= '0';
				     READ_AC <= '0';
				     INC_AC <= '0';
				     CLR_AC <= '0';
				     COM_AC <= '0';			     
				     SHL_AC <= '0';
				     SHR_AC <= '0';
				     LOAD_AR <= '0'; 
				     READ_AR <= '0';
				     READ_PC <= '0';
				     INC_PC <= '0'; 
				     CLR_PC <= '0';
				     LOAD_IR <= '0';
				     READ_IR <= '0';
				     LOAD_OUTR <= '0'; 
				     READ_OUTR <= '0';
				     READ_MEM <= '0';
				     WRITE_MEM <= '0';
				     
			end case;
		end if;
	end process;
	
end controlunit_arch;

					
						
						
						
					
				
				
		     
	     
