Library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

Entity reg_8bit is
	port(input:in std_logic_vector(7 downto 0);
	     clr, clk, inr, load:in std_logic;
	     output:out std_logic_vector(7 downto 0));
End reg_8bit;

Architecture reg_8bit_arch of reg_8bit is
	Signal input_signal, output_signal, mem_contents:std_logic_vector(7 downto 0);
	
	begin
		input_signal <= input;
		output <= mem_contents;
		
		clkpulse:process(clk, inr, load, clr)
		begin
			if(clk'event and clk ='1') then	--Positive edge triggered
				if(load = '1') then	
					mem_contents <= input_signal; --Load from bus
				else
					if (inr ='1') then
						mem_contents <= (mem_contents + 1);
					else
						if(clr = '1') then
							mem_contents <= "00000000";
						end if;
					end if;
				end if;
			end if;
			
			
		end process;
		
		
end reg_8bit_arch;
				
	
